<template>
  <div class="container mx-auto lg:py-12 px-2 lg:px-60">
    <my-header :small-format="false"></my-header>
    <!--    <div class="header-left-logo">-->
    <!--      <img src="/img/mobilizon-logo.svg?url" alt="" />-->
    <!--    </div>-->

    <main>
      <search-fields
        v-model:location="formLocation"
        v-model:search="search"
        @submit="doNewSearch"
      />

      <p
        :class="{ hidden: !instancesCount }"
        class="text-center max-w-lg mt-6 mb-12 mx-auto dark:text-zinc-300"
        v-html="
          $ngettext(
            'Search for your favorite events and groups on %{tagStart}one Mobilizon website%{tagEnd} indexed by %{indexName}!',
            'Search for your favorite events and groups on %{tagStart}%{instancesCount} Mobilizon websites%{tagEnd} indexed by %{indexName}!',
            instancesCount,
            {
              tagStart,
              tagEnd,
              indexName,
              instancesCount: instancesCount.toString(),
            },
            true
          )
        "
      />

      <search-warning />

      <div class="flex flex-wrap items-center justify-center gap-3 md:gap-5">
        <category
          v-for="category in promotedCategories"
          :key="category.key"
          :category="category"
          :with-details="false"
        />
        <router-link to="/categories">
          <div
            class="flex items-end brightness-85 h-36 w-36 md:h-52 md:w-52 rounded-lg font-semibold text-lg md:text-xl p-4 dark:text-white bg-gradient-to-r from-pink-500 via-red-500 to-yellow-500"
          >
            <span>
              {{ $gettext('View all categories') }}
            </span>
          </div>
        </router-link>
      </div>
      <close-events v-if="userLocation.name" @doGeoLoc="performGeoLocation()" />
      <close-groups v-if="userLocation.name" @doGeoLoc="performGeoLocation()" />
      <div
        v-if="!userLocation.lat"
        class="border dark:border-gray-700 shadow-md rounded-lg mt-10 p-6 flex flex-col gap-6 md:flex-row flex-center justify-around"
      >
        <div class="flex-1 flex flex-col justify-center">
          <h1
            class="text-xl sm:text-xl md:text-2xl lg:text-3xl xl:text-4xl dark:text-white font-bold leading-tight"
          >
            {{ $gettext('Explore events and groups near you') }}
          </h1>
          <p class="dark:text-white">
            {{
              $gettext(
                'Allow us to detect your position to find nearby events and groups'
              )
            }}
          </p>
        </div>
        <div class="flex justify-center">
          <button
            @click="performGeoLocation()"
            class="m-auto inline-flex px-8 py-3 text-white bg-indigo-600 border border-indigo-600 rounded hover:bg-transparent hover:text-indigo-600 active:text-indigo-500 focus:outline-none focus:ring"
          >
            <svg
              xmlns="http://www.w3.org/2000/svg"
              class="h-6 w-6"
              fill="none"
              viewBox="0 0 24 24"
              stroke="currentColor"
              stroke-width="2"
            >
              <path
                stroke-linecap="round"
                stroke-linejoin="round"
                d="M17.657 16.657L13.414 20.9a1.998 1.998 0 01-2.827 0l-4.244-4.243a8 8 0 1111.314 0z"
              />
              <path
                stroke-linecap="round"
                stroke-linejoin="round"
                d="M15 11a3 3 0 11-6 0 3 3 0 016 0z"
              />
            </svg>
            <span class="pl-2 text-sm font-medium">{{
              $gettext('Geolocate me')
            }}</span>
          </button>
        </div>
      </div>
      <online-events />
    </main>
  </div>
</template>
<script lang="ts" setup>
  import { computed, defineAsyncComponent, inject, reactive, ref } from 'vue'
  import MyHeader from '../components/Header.vue'
  import SearchWarning from '../components/SearchWarning.vue'
  import SearchFields from '../components/search/SearchFields.vue'
  import { categoriesWithPictures } from '@/query/constants'
  import { useGettext } from 'vue3-gettext'
  import { CategoryStatsModel } from '../../../shared/stats.model'
  import { shuffle } from 'lodash'
  import { getGeoLocationInformation } from '@/shared/search'
  import { useRouter } from 'vue-router'
  import { useHead } from '@vueuse/head'
  import { LocationType } from '../../../shared/user-location.model'
  import { ServerConfig } from '../../../shared'
  import { closest } from '@/shared/utils'

  const Category = defineAsyncComponent(
    () => import('../components/Category.vue')
  )
  const CloseEvents = defineAsyncComponent(
    () => import('../components/local/CloseEvents.vue')
  )
  const CloseGroups = defineAsyncComponent(
    () => import('../components/local/CloseGroups.vue')
  )
  const OnlineEvents = defineAsyncComponent(
    () => import('../components/local/OnlineEvents.vue')
  )

  const categoryStats = inject<CategoryStatsModel[]>('categoryStats')

  const tagStart = computed(() => {
    return `<a class="underline" href="${config.indexedInstancesUrl}" target="_blank">`
  })
  const tagEnd = '</a>'
  const promotedCategories = computed<CategoryStatsModel[]>(() => {
    return shuffle(
      categoryStats.filter(
        ({ key, doc_count }) =>
          key !== 'MEETING' &&
          doc_count >= 1 &&
          categoriesWithPictures.includes(key)
      )
    ).slice(0, 9)
  })

  const search = ref('')

  const config = inject<ServerConfig>('config')

  const instancesCount = computed(() => config.indexedHostsCount)
  const indexName = computed(() => config.searchInstanceName)

  const { userLocation, updateUserLocation } = inject<{
    userLocation: LocationType
    updateUserLocation: (newLocation: LocationType) => void
  }>('userLocation')

  const searchLocation = reactive<LocationType>({
    lon: null,
    lat: null,
    name: null,
  })

  const formLocation = computed<LocationType>({
    get() {
      return searchLocation.name !== null ? searchLocation : userLocation
    },
    set(newValue: LocationType) {
      searchLocation.lat = newValue.lat
      searchLocation.lon = newValue.lon
      searchLocation.name = newValue.name
    },
  })

  const performGeoLocation = () => {
    navigator.geolocation.getCurrentPosition(
      async ({ coords: { latitude, longitude, accuracy } }) => {
        const geoLocationInformation = await getGeoLocationInformation(
          latitude,
          longitude
        )
        console.debug(
          'geoLocationInformation',
          accuracy,
          geoLocationInformation
        )

        updateUserLocation({
          lat: latitude,
          lon: longitude,
          accuracy: Math.round(accuracy / 1000),
          isIPLocation: false,
          name:
            geoLocationInformation.address.addressLocality ||
            geoLocationInformation.address.addressRegion ||
            geoLocationInformation.address.addressCountry,
          picture: geoLocationInformation.picture_info,
        })
      }
    )
  }

  const router = useRouter()

  function doNewSearch(): void {
    const query: Record<string, string> = {}

    if (search.value) {
      query.search = search.value
    }

    if (formLocation.value.name) {
      query.locationName = formLocation.value.name
      query.lon = formLocation.value.lon.toString()
      query.lat = formLocation.value.lat.toString()
    }

    if (formLocation.value.name && formLocation.value.accuracy) {
      query.distance = `${closest(formLocation.value?.accuracy)}_km`
    }

    router.push({
      name: 'SEARCH',
      query,
    })
  }

  const { $gettext, $ngettext } = useGettext()

  useHead({
    title: computed(() =>
      $gettext(
        '%{indexName} - A search engine for Mobilizon events and groups',
        { indexName: indexName.value }
      )
    ),
    meta: [
      {
        name: `description`,
        content: computed(() => {
          return $ngettext(
            'Search for your favorite events and groups on one Mobilizon website indexed by %{indexName}!',
            'Search for your favorite events and groups on %{instancesCount} Mobilizon websites indexed by %{indexName}!',
            instancesCount.value,
            {
              indexName: indexName.value,
              instancesCount: instancesCount.value?.toString(),
            },
            true
          )
        }),
      },
    ],
  })
</script>
